/* EntryMultiCompletion.c generated by valac 0.56.17, the Vala compiler
 * generated from EntryMultiCompletion.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2017 Jens Georg <mail@jensge.org>
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/* Entry completion for values separated by separators (e.g. comma in the case of tags)*/
/* Partly inspired by the class of the same name in gtkmm-utils by Marko Anastasov*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ENTRY_MULTI_COMPLETION (entry_multi_completion_get_type ())
#define ENTRY_MULTI_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ENTRY_MULTI_COMPLETION, EntryMultiCompletion))
#define ENTRY_MULTI_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ENTRY_MULTI_COMPLETION, EntryMultiCompletionClass))
#define IS_ENTRY_MULTI_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ENTRY_MULTI_COMPLETION))
#define IS_ENTRY_MULTI_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ENTRY_MULTI_COMPLETION))
#define ENTRY_MULTI_COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ENTRY_MULTI_COMPLETION, EntryMultiCompletionClass))

typedef struct _EntryMultiCompletion EntryMultiCompletion;
typedef struct _EntryMultiCompletionClass EntryMultiCompletionClass;
typedef struct _EntryMultiCompletionPrivate EntryMultiCompletionPrivate;
enum  {
	ENTRY_MULTI_COMPLETION_0_PROPERTY,
	ENTRY_MULTI_COMPLETION_NUM_PROPERTIES
};
static GParamSpec* entry_multi_completion_properties[ENTRY_MULTI_COMPLETION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _EntryMultiCompletion {
	GtkEntryCompletion parent_instance;
	EntryMultiCompletionPrivate * priv;
};

struct _EntryMultiCompletionClass {
	GtkEntryCompletionClass parent_class;
};

struct _EntryMultiCompletionPrivate {
	gchar* delimiter;
};

static gint EntryMultiCompletion_private_offset;
static gpointer entry_multi_completion_parent_class = NULL;

VALA_EXTERN GType entry_multi_completion_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EntryMultiCompletion, g_object_unref)
VALA_EXTERN EntryMultiCompletion* entry_multi_completion_new (GeeCollection* completion_list,
                                                  const gchar* delimiter);
VALA_EXTERN EntryMultiCompletion* entry_multi_completion_construct (GType object_type,
                                                        GeeCollection* completion_list,
                                                        const gchar* delimiter);
static GtkListStore* entry_multi_completion_create_completion_store (GeeCollection* completion_list);
static gboolean entry_multi_completion_match_func (EntryMultiCompletion* self,
                                            GtkEntryCompletion* completion,
                                            const gchar* key,
                                            GtkTreeIter* iter);
static gboolean _entry_multi_completion_match_func_gtk_entry_completion_match_func (GtkEntryCompletion* completion,
                                                                             const gchar* key,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static gchar* entry_multi_completion_get_last_part (const gchar* s,
                                             const gchar* delimiter);
static gboolean entry_multi_completion_real_match_selected (GtkEntryCompletion* base,
                                                     GtkTreeModel* model,
                                                     GtkTreeIter* iter);
static void entry_multi_completion_finalize (GObject * obj);
static GType entry_multi_completion_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
entry_multi_completion_get_instance_private (EntryMultiCompletion* self)
{
	return G_STRUCT_MEMBER_P (self, EntryMultiCompletion_private_offset);
}

static gboolean
_entry_multi_completion_match_func_gtk_entry_completion_match_func (GtkEntryCompletion* completion,
                                                                    const gchar* key,
                                                                    GtkTreeIter* iter,
                                                                    gpointer self)
{
	gboolean result;
	result = entry_multi_completion_match_func ((EntryMultiCompletion*) self, completion, key, iter);
#line 19 "../src/dialogs/EntryMultiCompletion.vala"
	return result;
#line 126 "EntryMultiCompletion.c"
}

EntryMultiCompletion*
entry_multi_completion_construct (GType object_type,
                                  GeeCollection* completion_list,
                                  const gchar* delimiter)
{
	EntryMultiCompletion * self = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	GtkListStore* _tmp4_;
	GtkListStore* _tmp5_;
#line 13 "../src/dialogs/EntryMultiCompletion.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (completion_list, GEE_TYPE_COLLECTION), NULL);
#line 13 "../src/dialogs/EntryMultiCompletion.vala"
	self = (EntryMultiCompletion*) g_object_new (object_type, NULL);
#line 14 "../src/dialogs/EntryMultiCompletion.vala"
	if (delimiter == NULL) {
#line 14 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp0_ = TRUE;
#line 147 "EntryMultiCompletion.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 14 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp1_ = strlen (delimiter);
#line 14 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp2_ = _tmp1_;
#line 14 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp0_ = _tmp2_ == 1;
#line 157 "EntryMultiCompletion.c"
	}
#line 14 "../src/dialogs/EntryMultiCompletion.vala"
	_vala_assert (_tmp0_, "delimiter == null || delimiter.length == 1");
#line 15 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp3_ = g_strdup (delimiter);
#line 15 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (self->priv->delimiter);
#line 15 "../src/dialogs/EntryMultiCompletion.vala"
	self->priv->delimiter = _tmp3_;
#line 17 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp4_ = entry_multi_completion_create_completion_store (completion_list);
#line 17 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp5_ = _tmp4_;
#line 17 "../src/dialogs/EntryMultiCompletion.vala"
	gtk_entry_completion_set_model (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion), G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_tree_model_get_type (), GtkTreeModel));
#line 17 "../src/dialogs/EntryMultiCompletion.vala"
	_g_object_unref0 (_tmp5_);
#line 18 "../src/dialogs/EntryMultiCompletion.vala"
	gtk_entry_completion_set_text_column (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion), 0);
#line 19 "../src/dialogs/EntryMultiCompletion.vala"
	gtk_entry_completion_set_match_func (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion), _entry_multi_completion_match_func_gtk_entry_completion_match_func, g_object_ref (self), g_object_unref);
#line 13 "../src/dialogs/EntryMultiCompletion.vala"
	return self;
#line 181 "EntryMultiCompletion.c"
}

EntryMultiCompletion*
entry_multi_completion_new (GeeCollection* completion_list,
                            const gchar* delimiter)
{
#line 13 "../src/dialogs/EntryMultiCompletion.vala"
	return entry_multi_completion_construct (TYPE_ENTRY_MULTI_COMPLETION, completion_list, delimiter);
#line 190 "EntryMultiCompletion.c"
}

static GtkListStore*
entry_multi_completion_create_completion_store (GeeCollection* completion_list)
{
	GtkListStore* completion_store = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter store_iter = {0};
	GeeIterator* completion_iter = NULL;
	GeeIterator* _tmp1_;
	GtkListStore* result;
#line 22 "../src/dialogs/EntryMultiCompletion.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (completion_list, GEE_TYPE_COLLECTION), NULL);
#line 23 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp0_ = gtk_list_store_new (1, G_TYPE_STRING, -1);
#line 23 "../src/dialogs/EntryMultiCompletion.vala"
	completion_store = _tmp0_;
#line 25 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (completion_list, GEE_TYPE_ITERABLE, GeeIterable));
#line 25 "../src/dialogs/EntryMultiCompletion.vala"
	completion_iter = _tmp1_;
#line 26 "../src/dialogs/EntryMultiCompletion.vala"
	while (TRUE) {
#line 214 "EntryMultiCompletion.c"
		GeeIterator* _tmp2_;
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_ = {0};
		GtkListStore* _tmp5_;
		GtkTreeIter _tmp6_;
		GeeIterator* _tmp7_;
		gpointer _tmp8_;
		gchar* _tmp9_;
#line 26 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp2_ = completion_iter;
#line 26 "../src/dialogs/EntryMultiCompletion.vala"
		if (!gee_iterator_next (_tmp2_)) {
#line 26 "../src/dialogs/EntryMultiCompletion.vala"
			break;
#line 229 "EntryMultiCompletion.c"
		}
#line 27 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp3_ = completion_store;
#line 27 "../src/dialogs/EntryMultiCompletion.vala"
		gtk_list_store_append (_tmp3_, &_tmp4_);
#line 27 "../src/dialogs/EntryMultiCompletion.vala"
		store_iter = _tmp4_;
#line 28 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp5_ = completion_store;
#line 28 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp6_ = store_iter;
#line 28 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp7_ = completion_iter;
#line 28 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp8_ = gee_iterator_get (_tmp7_);
#line 28 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp9_ = (gchar*) _tmp8_;
#line 28 "../src/dialogs/EntryMultiCompletion.vala"
		gtk_list_store_set (_tmp5_, &_tmp6_, 0, _tmp9_, -1, -1);
#line 28 "../src/dialogs/EntryMultiCompletion.vala"
		_g_free0 (_tmp9_);
#line 251 "EntryMultiCompletion.c"
	}
#line 31 "../src/dialogs/EntryMultiCompletion.vala"
	result = completion_store;
#line 31 "../src/dialogs/EntryMultiCompletion.vala"
	_g_object_unref0 (completion_iter);
#line 31 "../src/dialogs/EntryMultiCompletion.vala"
	return result;
#line 259 "EntryMultiCompletion.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "../src/dialogs/EntryMultiCompletion.vala"
	return self ? g_object_ref (self) : NULL;
#line 267 "EntryMultiCompletion.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 288 "EntryMultiCompletion.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 307 "EntryMultiCompletion.c"
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1214 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1215 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1215 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1217 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1217 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 329 "EntryMultiCompletion.c"
		gchar* _tmp2_;
#line 1218 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1218 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1218 "glib-2.0.vapi"
		return result;
#line 337 "EntryMultiCompletion.c"
	} else {
#line 1220 "glib-2.0.vapi"
		result = -1;
#line 1220 "glib-2.0.vapi"
		return result;
#line 343 "EntryMultiCompletion.c"
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 361 "EntryMultiCompletion.c"
}

static gboolean
entry_multi_completion_match_func (EntryMultiCompletion* self,
                                   GtkEntryCompletion* completion,
                                   const gchar* key,
                                   GtkTreeIter* iter)
{
	GtkTreeModel* model = NULL;
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	gchar* possible_match = NULL;
	GtkTreeModel* _tmp2_;
	GtkTreeIter _tmp3_;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* normed_key = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gboolean result;
#line 34 "../src/dialogs/EntryMultiCompletion.vala"
	g_return_val_if_fail (IS_ENTRY_MULTI_COMPLETION (self), FALSE);
#line 34 "../src/dialogs/EntryMultiCompletion.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (completion, gtk_entry_completion_get_type ()), FALSE);
#line 34 "../src/dialogs/EntryMultiCompletion.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 34 "../src/dialogs/EntryMultiCompletion.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 35 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp0_ = gtk_entry_completion_get_model (completion);
#line 35 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 35 "../src/dialogs/EntryMultiCompletion.vala"
	model = _tmp1_;
#line 37 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp2_ = model;
#line 37 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp3_ = *iter;
#line 37 "../src/dialogs/EntryMultiCompletion.vala"
	gtk_tree_model_get (_tmp2_, &_tmp3_, 0, &_tmp4_, -1);
#line 37 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (possible_match);
#line 37 "../src/dialogs/EntryMultiCompletion.vala"
	possible_match = _tmp4_;
#line 43 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp5_ = possible_match;
#line 43 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp6_ = g_utf8_casefold (_tmp5_, (gssize) -1);
#line 43 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp7_ = _tmp6_;
#line 43 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp8_ = g_utf8_normalize (_tmp7_, (gssize) -1, G_NORMALIZE_ALL_COMPOSE);
#line 43 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (possible_match);
#line 43 "../src/dialogs/EntryMultiCompletion.vala"
	possible_match = _tmp8_;
#line 43 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (_tmp7_);
#line 44 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp9_ = g_utf8_normalize (key, (gssize) -1, G_NORMALIZE_ALL_COMPOSE);
#line 44 "../src/dialogs/EntryMultiCompletion.vala"
	normed_key = _tmp9_;
#line 46 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp10_ = self->priv->delimiter;
#line 46 "../src/dialogs/EntryMultiCompletion.vala"
	if (_tmp10_ == NULL) {
#line 431 "EntryMultiCompletion.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_;
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp11_ = possible_match;
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp12_ = normed_key;
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp13_ = string_strip (_tmp12_);
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp14_ = _tmp13_;
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp15_ = g_str_has_prefix (_tmp11_, _tmp14_);
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		_g_free0 (_tmp14_);
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		result = _tmp15_;
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		_g_free0 (normed_key);
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		_g_free0 (possible_match);
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		_g_object_unref0 (model);
#line 47 "../src/dialogs/EntryMultiCompletion.vala"
		return result;
#line 459 "EntryMultiCompletion.c"
	} else {
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* last_part = NULL;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		const gchar* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gboolean _tmp35_;
#line 49 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp16_ = normed_key;
#line 49 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp17_ = self->priv->delimiter;
#line 49 "../src/dialogs/EntryMultiCompletion.vala"
		if (string_contains (_tmp16_, _tmp17_)) {
#line 484 "EntryMultiCompletion.c"
			gint offset = 0;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gint position = 0;
			GtkWidget* _tmp21_;
#line 51 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp18_ = normed_key;
#line 51 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp19_ = normed_key;
#line 51 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp20_ = self->priv->delimiter;
#line 51 "../src/dialogs/EntryMultiCompletion.vala"
			offset = g_utf8_strlen (_tmp18_, (gssize) string_last_index_of_char (_tmp19_, (gunichar) string_get (_tmp20_, (glong) 0), 0));
#line 52 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp21_ = gtk_entry_completion_get_entry (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion));
#line 52 "../src/dialogs/EntryMultiCompletion.vala"
			position = gtk_editable_get_position (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_entry_get_type (), GtkEntry), gtk_editable_get_type (), GtkEditable));
#line 53 "../src/dialogs/EntryMultiCompletion.vala"
			if (position <= offset) {
#line 54 "../src/dialogs/EntryMultiCompletion.vala"
				result = FALSE;
#line 54 "../src/dialogs/EntryMultiCompletion.vala"
				_g_free0 (normed_key);
#line 54 "../src/dialogs/EntryMultiCompletion.vala"
				_g_free0 (possible_match);
#line 54 "../src/dialogs/EntryMultiCompletion.vala"
				_g_object_unref0 (model);
#line 54 "../src/dialogs/EntryMultiCompletion.vala"
				return result;
#line 515 "EntryMultiCompletion.c"
			}
		}
#line 57 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp22_ = normed_key;
#line 57 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp23_ = string_strip (_tmp22_);
#line 57 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp24_ = _tmp23_;
#line 57 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp25_ = self->priv->delimiter;
#line 57 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp26_ = entry_multi_completion_get_last_part (_tmp24_, _tmp25_);
#line 57 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp27_ = _tmp26_;
#line 57 "../src/dialogs/EntryMultiCompletion.vala"
		_g_free0 (_tmp24_);
#line 57 "../src/dialogs/EntryMultiCompletion.vala"
		last_part = _tmp27_;
#line 59 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp28_ = last_part;
#line 59 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp29_ = strlen (_tmp28_);
#line 59 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp30_ = _tmp29_;
#line 59 "../src/dialogs/EntryMultiCompletion.vala"
		if (_tmp30_ == 0) {
#line 60 "../src/dialogs/EntryMultiCompletion.vala"
			result = FALSE;
#line 60 "../src/dialogs/EntryMultiCompletion.vala"
			_g_free0 (last_part);
#line 60 "../src/dialogs/EntryMultiCompletion.vala"
			_g_free0 (normed_key);
#line 60 "../src/dialogs/EntryMultiCompletion.vala"
			_g_free0 (possible_match);
#line 60 "../src/dialogs/EntryMultiCompletion.vala"
			_g_object_unref0 (model);
#line 60 "../src/dialogs/EntryMultiCompletion.vala"
			return result;
#line 554 "EntryMultiCompletion.c"
		}
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp31_ = possible_match;
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp32_ = last_part;
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp33_ = string_strip (_tmp32_);
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp34_ = _tmp33_;
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp35_ = g_str_has_prefix (_tmp31_, _tmp34_);
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		_g_free0 (_tmp34_);
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		result = _tmp35_;
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		_g_free0 (last_part);
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		_g_free0 (normed_key);
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		_g_free0 (possible_match);
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		_g_object_unref0 (model);
#line 62 "../src/dialogs/EntryMultiCompletion.vala"
		return result;
#line 580 "EntryMultiCompletion.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 604 "EntryMultiCompletion.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 613 "EntryMultiCompletion.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 632 "EntryMultiCompletion.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 636 "EntryMultiCompletion.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 642 "EntryMultiCompletion.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 652 "EntryMultiCompletion.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 660 "EntryMultiCompletion.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 664 "EntryMultiCompletion.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 670 "EntryMultiCompletion.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 680 "EntryMultiCompletion.c"
}

static gboolean
entry_multi_completion_real_match_selected (GtkEntryCompletion* base,
                                            GtkTreeModel* model,
                                            GtkTreeIter* iter)
{
	EntryMultiCompletion * self;
	gchar* match = NULL;
	GtkTreeIter _tmp0_;
	gchar* _tmp1_ = NULL;
	GtkEntry* entry = NULL;
	GtkWidget* _tmp2_;
	GtkEntry* _tmp3_;
	gchar* old_text = NULL;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	const gchar* _tmp21_ = NULL;
	const gchar* _tmp22_;
	gchar* new_text = NULL;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GtkEntry* _tmp32_;
	GtkEntry* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	gboolean result;
#line 66 "../src/dialogs/EntryMultiCompletion.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ENTRY_MULTI_COMPLETION, EntryMultiCompletion);
#line 66 "../src/dialogs/EntryMultiCompletion.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (model, gtk_tree_model_get_type ()), FALSE);
#line 66 "../src/dialogs/EntryMultiCompletion.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 68 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp0_ = *iter;
#line 68 "../src/dialogs/EntryMultiCompletion.vala"
	gtk_tree_model_get (model, &_tmp0_, 0, &_tmp1_, -1);
#line 68 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (match);
#line 68 "../src/dialogs/EntryMultiCompletion.vala"
	match = _tmp1_;
#line 70 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp2_ = gtk_entry_completion_get_entry (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_completion_get_type (), GtkEntryCompletion));
#line 70 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_entry_get_type (), GtkEntry));
#line 70 "../src/dialogs/EntryMultiCompletion.vala"
	entry = _tmp3_;
#line 72 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp4_ = entry;
#line 72 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 72 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp6_ = g_utf8_normalize (_tmp5_, (gssize) -1, G_NORMALIZE_ALL_COMPOSE);
#line 72 "../src/dialogs/EntryMultiCompletion.vala"
	old_text = _tmp6_;
#line 73 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp7_ = old_text;
#line 73 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp8_ = strlen (_tmp7_);
#line 73 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp9_ = _tmp8_;
#line 73 "../src/dialogs/EntryMultiCompletion.vala"
	if (_tmp9_ > 0) {
#line 755 "EntryMultiCompletion.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 74 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp10_ = old_text;
#line 74 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp11_ = self->priv->delimiter;
#line 74 "../src/dialogs/EntryMultiCompletion.vala"
		if (string_contains (_tmp10_, _tmp11_)) {
#line 764 "EntryMultiCompletion.c"
			const gchar* _tmp12_ = NULL;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp13_ = self->priv->delimiter;
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			if (g_strcmp0 (_tmp13_, " ") != 0) {
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
				_tmp12_ = " ";
#line 779 "EntryMultiCompletion.c"
			} else {
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
				_tmp12_ = "";
#line 783 "EntryMultiCompletion.c"
			}
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp14_ = old_text;
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp15_ = old_text;
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp16_ = self->priv->delimiter;
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp17_ = string_substring (_tmp14_, (glong) 0, (glong) (string_last_index_of_char (_tmp15_, (gunichar) string_get (_tmp16_, (glong) 0), 0) + 1));
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp18_ = _tmp17_;
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp19_ = g_strconcat (_tmp18_, _tmp12_, NULL);
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			_g_free0 (old_text);
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			old_text = _tmp19_;
#line 75 "../src/dialogs/EntryMultiCompletion.vala"
			_g_free0 (_tmp18_);
#line 803 "EntryMultiCompletion.c"
		} else {
			gchar* _tmp20_;
#line 77 "../src/dialogs/EntryMultiCompletion.vala"
			_tmp20_ = g_strdup ("");
#line 77 "../src/dialogs/EntryMultiCompletion.vala"
			_g_free0 (old_text);
#line 77 "../src/dialogs/EntryMultiCompletion.vala"
			old_text = _tmp20_;
#line 812 "EntryMultiCompletion.c"
		}
	}
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp22_ = self->priv->delimiter;
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	if (g_strcmp0 (_tmp22_, " ") != 0) {
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp21_ = " ";
#line 821 "EntryMultiCompletion.c"
	} else {
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp21_ = "";
#line 825 "EntryMultiCompletion.c"
	}
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp23_ = old_text;
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp24_ = match;
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp25_ = g_strconcat (_tmp23_, _tmp24_, NULL);
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp26_ = _tmp25_;
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp27_ = self->priv->delimiter;
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp28_ = g_strconcat (_tmp26_, _tmp27_, NULL);
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp29_ = _tmp28_;
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp30_ = g_strconcat (_tmp29_, _tmp21_, NULL);
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp31_ = _tmp30_;
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (_tmp29_);
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (_tmp26_);
#line 80 "../src/dialogs/EntryMultiCompletion.vala"
	new_text = _tmp31_;
#line 81 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp32_ = entry;
#line 81 "../src/dialogs/EntryMultiCompletion.vala"
	gtk_entry_set_text (_tmp32_, new_text);
#line 82 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp33_ = entry;
#line 82 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp34_ = strlen (new_text);
#line 82 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp35_ = _tmp34_;
#line 82 "../src/dialogs/EntryMultiCompletion.vala"
	gtk_editable_set_position (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, gtk_editable_get_type (), GtkEditable), (gint) _tmp35_);
#line 84 "../src/dialogs/EntryMultiCompletion.vala"
	result = TRUE;
#line 84 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (new_text);
#line 84 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (old_text);
#line 84 "../src/dialogs/EntryMultiCompletion.vala"
	_g_object_unref0 (entry);
#line 84 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (match);
#line 84 "../src/dialogs/EntryMultiCompletion.vala"
	return result;
#line 875 "EntryMultiCompletion.c"
}

static gchar*
entry_multi_completion_get_last_part (const gchar* s,
                                      const gchar* delimiter)
{
	gchar** split = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint split_length1;
	gint _split_size_;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* result;
#line 88 "../src/dialogs/EntryMultiCompletion.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 88 "../src/dialogs/EntryMultiCompletion.vala"
	g_return_val_if_fail (delimiter != NULL, NULL);
#line 89 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp1_ = _tmp0_ = g_strsplit (s, delimiter, 0);
#line 89 "../src/dialogs/EntryMultiCompletion.vala"
	split = _tmp1_;
#line 89 "../src/dialogs/EntryMultiCompletion.vala"
	split_length1 = _vala_array_length (_tmp0_);
#line 89 "../src/dialogs/EntryMultiCompletion.vala"
	_split_size_ = split_length1;
#line 91 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp3_ = split;
#line 91 "../src/dialogs/EntryMultiCompletion.vala"
	_tmp3__length1 = split_length1;
#line 91 "../src/dialogs/EntryMultiCompletion.vala"
	if (_tmp3_ != NULL) {
#line 909 "EntryMultiCompletion.c"
		gchar** _tmp4_;
		gint _tmp4__length1;
		const gchar* _tmp5_;
#line 91 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp4_ = split;
#line 91 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp4__length1 = split_length1;
#line 91 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp5_ = _tmp4_[0];
#line 91 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp2_ = _tmp5_ != NULL;
#line 921 "EntryMultiCompletion.c"
	} else {
#line 91 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp2_ = FALSE;
#line 925 "EntryMultiCompletion.c"
	}
#line 91 "../src/dialogs/EntryMultiCompletion.vala"
	if (_tmp2_) {
#line 929 "EntryMultiCompletion.c"
		gchar** _tmp6_;
		gint _tmp6__length1;
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 92 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp6_ = split;
#line 92 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp6__length1 = split_length1;
#line 92 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp7_ = split;
#line 92 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp7__length1 = split_length1;
#line 92 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp8_ = _tmp6_[_tmp7__length1 - 1];
#line 92 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 92 "../src/dialogs/EntryMultiCompletion.vala"
		result = _tmp9_;
#line 92 "../src/dialogs/EntryMultiCompletion.vala"
		split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
#line 92 "../src/dialogs/EntryMultiCompletion.vala"
		return result;
#line 954 "EntryMultiCompletion.c"
	} else {
		gchar* _tmp10_;
#line 94 "../src/dialogs/EntryMultiCompletion.vala"
		_tmp10_ = g_strdup ("");
#line 94 "../src/dialogs/EntryMultiCompletion.vala"
		result = _tmp10_;
#line 94 "../src/dialogs/EntryMultiCompletion.vala"
		split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/dialogs/EntryMultiCompletion.vala"
		return result;
#line 965 "EntryMultiCompletion.c"
	}
}

static void
entry_multi_completion_class_init (EntryMultiCompletionClass * klass,
                                   gpointer klass_data)
{
#line 10 "../src/dialogs/EntryMultiCompletion.vala"
	entry_multi_completion_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/dialogs/EntryMultiCompletion.vala"
	g_type_class_adjust_private_offset (klass, &EntryMultiCompletion_private_offset);
#line 10 "../src/dialogs/EntryMultiCompletion.vala"
	((GtkEntryCompletionClass *) klass)->match_selected = (gboolean (*) (GtkEntryCompletion*, GtkTreeModel*, GtkTreeIter*)) entry_multi_completion_real_match_selected;
#line 10 "../src/dialogs/EntryMultiCompletion.vala"
	G_OBJECT_CLASS (klass)->finalize = entry_multi_completion_finalize;
#line 981 "EntryMultiCompletion.c"
}

static void
entry_multi_completion_instance_init (EntryMultiCompletion * self,
                                      gpointer klass)
{
#line 10 "../src/dialogs/EntryMultiCompletion.vala"
	self->priv = entry_multi_completion_get_instance_private (self);
#line 990 "EntryMultiCompletion.c"
}

static void
entry_multi_completion_finalize (GObject * obj)
{
	EntryMultiCompletion * self;
#line 10 "../src/dialogs/EntryMultiCompletion.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ENTRY_MULTI_COMPLETION, EntryMultiCompletion);
#line 11 "../src/dialogs/EntryMultiCompletion.vala"
	_g_free0 (self->priv->delimiter);
#line 10 "../src/dialogs/EntryMultiCompletion.vala"
	G_OBJECT_CLASS (entry_multi_completion_parent_class)->finalize (obj);
#line 1003 "EntryMultiCompletion.c"
}

static GType
entry_multi_completion_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EntryMultiCompletionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) entry_multi_completion_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EntryMultiCompletion), 0, (GInstanceInitFunc) entry_multi_completion_instance_init, NULL };
	GType entry_multi_completion_type_id;
	entry_multi_completion_type_id = g_type_register_static (gtk_entry_completion_get_type (), "EntryMultiCompletion", &g_define_type_info, 0);
	EntryMultiCompletion_private_offset = g_type_add_instance_private (entry_multi_completion_type_id, sizeof (EntryMultiCompletionPrivate));
	return entry_multi_completion_type_id;
}

GType
entry_multi_completion_get_type (void)
{
	static volatile gsize entry_multi_completion_type_id__once = 0;
	if (g_once_init_enter (&entry_multi_completion_type_id__once)) {
		GType entry_multi_completion_type_id;
		entry_multi_completion_type_id = entry_multi_completion_get_type_once ();
		g_once_init_leave (&entry_multi_completion_type_id__once, entry_multi_completion_type_id);
	}
	return entry_multi_completion_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

